import { NetworkType } from 'symbol-sdk';
import { Logger } from '../logger';
export declare type Password = string | false | undefined;
export declare class KnownError extends Error {
    readonly known = true;
}
/**
 * The operation to migrate the data.
 */
export interface Migration {
    readonly description: string;
    migrate(from: any): any;
}
export declare class BootstrapUtils {
    static stopProcess: boolean;
    private static onProcessListener;
    static toAns1(privateKey: string): string;
    static sleep(ms: number): Promise<any>;
    static poll(logger: Logger, promiseFunction: () => Promise<boolean>, totalPollingTime: number, pollIntervalMs: number): Promise<boolean>;
    static generateConfiguration(templateContext: any, copyFrom: string, copyTo: string, excludeFiles?: string[], includeFiles?: string[]): Promise<void>;
    static runTemplate(template: string, templateContext: any): string;
    static writeYaml(path: string, object: any, password: string | undefined): Promise<void>;
    static pruneEmpty(obj: any): any;
    static toYaml(object: any): string;
    static fromYaml(yamlString: string): any;
    static loadYaml(fileLocation: string, password: Password): any;
    static loadFileAsText(fileLocation: string): string;
    static writeTextFile(path: string, text: string): Promise<void>;
    static readTextFile(path: string): Promise<string>;
    private static initialize;
    private static add;
    private static minus;
    static computerMemory(percentage: number): number;
    static toAmount(renderedText: string | number): string;
    static toHex(renderedText: string): string;
    static toSimpleHex(renderedText: string): string;
    static toJson(object: any): string;
    static formatJson(string: string): string;
    static splitCsv(object: string): string[];
    static toSeconds(serverDuration: string): number;
    static migrate<T extends {
        version?: number;
    }>(logger: Logger, entityName: string, versioned: T, migrations?: Migration[]): T;
    static getNetworkIdentifier(networkType: NetworkType): string;
    static getNetworkName(networkType: NetworkType): string;
    static resolveWorkingDirPath(workingDir: string, path: string): string;
    static createDerFile(privateKey: string, file: string): void;
    static isYmlFile(string: string): boolean;
    static validatePassword(password: string): string;
}
